package com.hfkj.dao;

import com.hfkj.entity.CmsPatch;
import com.hfkj.entity.CmsPatchExample;
import com.hfkj.entity.CmsPatchExample.Criteria;
import com.hfkj.entity.CmsPatchExample.Criterion;
import org.apache.ibatis.jdbc.SQL;

import java.util.List;
import java.util.Map;

public class CmsPatchSqlProvider {

    public String countByExample(CmsPatchExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("cms_patch");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(CmsPatchExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("cms_patch");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(CmsPatch record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("cms_patch");
        
        if (record.getContentId() != null) {
            sql.VALUES("content_id", "#{contentId,jdbcType=BIGINT}");
        }
        
        if (record.getPatchName() != null) {
            sql.VALUES("patch_name", "#{patchName,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchDesc() != null) {
            sql.VALUES("patch_desc", "#{patchDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchType() != null) {
            sql.VALUES("patch_type", "#{patchType,jdbcType=INTEGER}");
        }
        
        if (record.getPatchPath() != null) {
            sql.VALUES("patch_path", "#{patchPath,jdbcType=VARCHAR}");
        }
        
        if (record.getVideoPath() != null) {
            sql.VALUES("video_path", "#{videoPath,jdbcType=VARCHAR}");
        }
        
        if (record.getSource() != null) {
            sql.VALUES("`source`", "#{source,jdbcType=INTEGER}");
        }
        
        if (record.getSort() != null) {
            sql.VALUES("sort", "#{sort,jdbcType=INTEGER}");
        }
        
        if (record.getAddTime() != null) {
            sql.VALUES("add_time", "#{addTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(CmsPatchExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("content_id");
        sql.SELECT("patch_name");
        sql.SELECT("patch_desc");
        sql.SELECT("patch_type");
        sql.SELECT("patch_path");
        sql.SELECT("video_path");
        sql.SELECT("`source`");
        sql.SELECT("sort");
        sql.SELECT("add_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("cms_patch");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        CmsPatch record = (CmsPatch) parameter.get("record");
        CmsPatchExample example = (CmsPatchExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("cms_patch");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getContentId() != null) {
            sql.SET("content_id = #{record.contentId,jdbcType=BIGINT}");
        }
        
        if (record.getPatchName() != null) {
            sql.SET("patch_name = #{record.patchName,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchDesc() != null) {
            sql.SET("patch_desc = #{record.patchDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchType() != null) {
            sql.SET("patch_type = #{record.patchType,jdbcType=INTEGER}");
        }
        
        if (record.getPatchPath() != null) {
            sql.SET("patch_path = #{record.patchPath,jdbcType=VARCHAR}");
        }
        
        if (record.getVideoPath() != null) {
            sql.SET("video_path = #{record.videoPath,jdbcType=VARCHAR}");
        }
        
        if (record.getSource() != null) {
            sql.SET("`source` = #{record.source,jdbcType=INTEGER}");
        }
        
        if (record.getSort() != null) {
            sql.SET("sort = #{record.sort,jdbcType=INTEGER}");
        }
        
        if (record.getAddTime() != null) {
            sql.SET("add_time = #{record.addTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("cms_patch");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("content_id = #{record.contentId,jdbcType=BIGINT}");
        sql.SET("patch_name = #{record.patchName,jdbcType=VARCHAR}");
        sql.SET("patch_desc = #{record.patchDesc,jdbcType=VARCHAR}");
        sql.SET("patch_type = #{record.patchType,jdbcType=INTEGER}");
        sql.SET("patch_path = #{record.patchPath,jdbcType=VARCHAR}");
        sql.SET("video_path = #{record.videoPath,jdbcType=VARCHAR}");
        sql.SET("`source` = #{record.source,jdbcType=INTEGER}");
        sql.SET("sort = #{record.sort,jdbcType=INTEGER}");
        sql.SET("add_time = #{record.addTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        CmsPatchExample example = (CmsPatchExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(CmsPatch record) {
        SQL sql = new SQL();
        sql.UPDATE("cms_patch");
        
        if (record.getContentId() != null) {
            sql.SET("content_id = #{contentId,jdbcType=BIGINT}");
        }
        
        if (record.getPatchName() != null) {
            sql.SET("patch_name = #{patchName,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchDesc() != null) {
            sql.SET("patch_desc = #{patchDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getPatchType() != null) {
            sql.SET("patch_type = #{patchType,jdbcType=INTEGER}");
        }
        
        if (record.getPatchPath() != null) {
            sql.SET("patch_path = #{patchPath,jdbcType=VARCHAR}");
        }
        
        if (record.getVideoPath() != null) {
            sql.SET("video_path = #{videoPath,jdbcType=VARCHAR}");
        }
        
        if (record.getSource() != null) {
            sql.SET("`source` = #{source,jdbcType=INTEGER}");
        }
        
        if (record.getSort() != null) {
            sql.SET("sort = #{sort,jdbcType=INTEGER}");
        }
        
        if (record.getAddTime() != null) {
            sql.SET("add_time = #{addTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, CmsPatchExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}
